"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getTransformer;

var _lodash = _interopRequireDefault(require("lodash.isplainobject"));

var _lodash2 = _interopRequireDefault(require("lodash.isfunction"));

var _lodash3 = _interopRequireDefault(require("lodash.tail"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var defaultConf = {
  // defaultRootTransform: undefined,
  // leafTransform: undefined,
  maxDepth: 100 // transforms: {
  //   // '%tag%': (args) => { ... }
  // },

};

function funcInObj(key, obj, args, defaultReturn) {
  if (key in obj) {
    // console.log('funcInObj:', key, 'ARGS:', args, 'CTX:', 'DEF:', defaultReturn);
    var func = obj[key]; // console.log('funcInObj func:', typeof func, func, isFunction(func) && func(args));

    return (0, _lodash2["default"])(func) ? func(args) : func;
  }

  return defaultReturn;
}

function transform(conf, obj, trs) {
  var level = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  if (level > conf.maxDepth) return obj;

  if (Array.isArray(obj)) {
    var newArray = obj.map(function (v) {
      return transform(conf, v, trs, level + 1);
    });
    var args = newArray.length > 2 && !Array.isArray(newArray[1]) ? (0, _lodash3["default"])(newArray) : newArray[1];
    return funcInObj(newArray[0], trs, args, newArray);
  }

  if ((0, _lodash["default"])(obj)) {
    var newObj = Object.entries(obj).reduce(function (r, _ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      /* eslint-disable no-param-reassign */
      r[k] = transform(conf, v, trs, level + 1);

      if (level === 0 && conf.defaultLevel1Transform) {
        r[k] = conf.defaultLevel1Transform(r[k], k);
      }
      /* eslint-enable no-param-reassign */


      return r;
    }, {});
    var key = Object.keys(newObj)[0];
    return funcInObj(key, trs, newObj[key], newObj);
  }

  return conf.leafTransform ? conf.leafTransform(obj) : obj;
}

var transformer = function transformer(conf) {
  return function (obj, transforms) {
    var result = transform(conf, obj, transforms ? _objectSpread(_objectSpread({}, conf.transforms), transforms) : conf.transforms);

    if (conf.defaultRootTransform) {
      result = conf.defaultRootTransform(result);
    }

    return result;
  };
};

function getTransformer(config) {
  return transformer(_objectSpread(_objectSpread({
    transforms: {}
  }, defaultConf), config));
}
